// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcItemDataFieldNames          = builder.RawFieldNames(&DcItemData{})
	dcItemDataRows                = strings.Join(dcItemDataFieldNames, ",")
	dcItemDataRowsExpectAutoSet   = strings.Join(stringx.Remove(dcItemDataFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcItemDataRowsWithPlaceHolder = strings.Join(stringx.Remove(dcItemDataFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcItemDataModel interface {
		Insert(ctx context.Context, data *DcItemData) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcItemData, error)
		Update(ctx context.Context, data *DcItemData) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcItemDataModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcItemData struct {
		Id        int64     `db:"id"`
		ProjectId int64     `db:"project_id"`
		Item      string    `db:"item"`
		Val       string    `db:"val"`
		Htime     time.Time `db:"htime"`
		Tag       string    `db:"tag"`
	}
)

func newDcItemDataModel(conn sqlx.SqlConn) *defaultDcItemDataModel {
	return &defaultDcItemDataModel{
		conn:  conn,
		table: "`dc_item_data`",
	}
}

func (m *defaultDcItemDataModel) withSession(session sqlx.Session) *defaultDcItemDataModel {
	return &defaultDcItemDataModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_item_data`",
	}
}

func (m *defaultDcItemDataModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcItemDataModel) FindOne(ctx context.Context, id int64) (*DcItemData, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcItemDataRows, m.table)
	var resp DcItemData
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcItemDataModel) Insert(ctx context.Context, data *DcItemData) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, dcItemDataRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.Item, data.Val, data.Htime, data.Tag)
	return ret, err
}

func (m *defaultDcItemDataModel) Update(ctx context.Context, data *DcItemData) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcItemDataRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.Item, data.Val, data.Htime, data.Tag, data.Id)
	return err
}

func (m *defaultDcItemDataModel) tableName() string {
	return m.table
}
